'-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
'------------------------------------------------------------------------------UNIVARIATE SPECTRAL ANALYSIS ADD-IN------------------------------------------------------------------------------
'-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

'-------------------------------------------------Dialog Windows----------------------------------------

'Arguments for the dialog windows.
%title="Spectral Analysis" 
%window="Smoothing Window:"
%menu = """Periodogram"" ""Hamming"" Hann Bartlett Parzen Truncated Daniell Bartlett-Priestley"
%truncation_="20"
%title1="Spectral Filter"
%cycle_form="Cycle Form"
%cycle_type="""Cycle Sum"" Individual-Cycles"
%max_p_value="For example: 0.05 or 2"
%name = _this.@name 'Series object name
%myname="                                                                                                                         Written by:                                         Nicolas Ronderos Pulido (2014)."
%myname1="Written by:                                         Nicolas Ronderos Pulido (2014)."

'Control variables (defaults)
scalar check1=0 'No periodogram components by default.
scalar check2=1 'Periodogram by default from the %menu list.
scalar check3=1 'Output table by default.
scalar check4=0 'No significance signal test by default.
scalar check5=0 'No log scale by default.
scalar check6=1 'For the spectral filter, cycle sum by default.
scalar check7=1 'For the spectral filter, weighted cycle by default.

'Arguments for command line
%window_1=@str(@hasoption("Periodogram")) 'Window types.
%window_2=@str(@hasoption("Hamming"))
%window_3=@str(@hasoption("Hann"))
%window_4=@str(@hasoption("Bartlett"))
%window_5=@str(@hasoption("Parzen"))
%window_6=@str(@hasoption("Truncated"))
%window_7=@str(@hasoption("Daniell"))
%window_8=@str(@hasoption("Bartlett-Priestley"))
%truncation=@equaloption("Truncation") 'Truncation point.
%o_table=@str(@hasoption("Table")) 'Output table.
%option_1=@str(@hasoption("T")) 'Significance signal test.
%option_2=@str(@hasoption("C")) 'Periodogram components.
%option_3=@str(@hasoption("Log")) 'Log scale.
'Arguments for the spectral filter
%cycles_prob=@equaloption("Criteria") 'Criteria for cycle selection: P-value or maximum ordinate.
%option_4=@str(@hasoption("NW")) 'Non weighted cycle if the user requested, otherwise weighted cycle.
%option_6=@str(@hasoption("Individual")) 'Individual cycle if the user requested, otherwise cycle sum.

%arguments=%window_1+%window_2+%window_3+%window_4+%window_5+%window_6+%window_7+%window_8+%o_table+%option_1+%option_2+%option_3+%cycles_prob+%option_4+%option_5+%option_6 ' @hasoption arguments
%arguments1=%cycles_prob+%truncation ' @equaloption arguments

if %arguments="00000000000000" and %arguments1=""  then ' If any argument from command line were given, then a dialog  window will emerge.
	!result = @uidialog("edit", %name,"Variable (Series Object):","radio",check2,%window,%menu,"edit",%truncation_,"Truncation point:","Check",check3,"Output Table","Check",check4,"Signal Significance Tests","Check",check1,"Periodogram Components (A and B)","Check",check5,"Log Scale","Caption",%title,"text",%myname)
	if !result=-1 then ' Cancel
		delete check1 check2 check3 check4 check5 check6 check7
		stop
	endif
	
	if !result=0 then ' If "ok" was pressed then a dialog window will emerge.
		%question="Would you like to generate optimum cycles?"
		scalar choice=1
		!result1=@uiradio(choice,%question,"Yes No")
	endif
	
	if !result1=-1 then 'Cancel
		delete check1 check2 check3 check4 check5 check6 check7 choice
		stop
	endif
	
	if !result1=0 and choice=1 then ' If the user requested optimum cycles, a dialog window will emerge.
		!result2=@uidialog("edit",%max_p_value,"P-Value or Number of Cycles ","Check",check7,"Weighted Cycle","radio",check6,%cycle_form,%cycle_type,"Caption",%title1,"text",%myname1)
		if !result2=-1 then 'Cancel
			delete check1 check2 check3 check4 check5 check6 check7 choice
			stop
		endif
	endif
	
else 'If some command line arguments were introduced.
	
	if %window_1="1" then 'Change control variables according the user line command arguments.
		check2=1
	endif
	if %window_2="1" then
		check2=2
	endif
	if %window_3="1" then
		check2=3
	endif
	if %window_4="1" then
		check2=4
	endif
	if %window_5="1" then
		check2=5
	endif
	if %window_6="1" then
		check2=6
	endif
	if %window_7="1" then
		check2=7
	endif
	if %window_8="1" then
		check2=8
	endif
	if %truncation<>"" then 'Default 20 in other case.
		%truncation_=%truncation   
	endif
	if %o_table<>"1" then
		check3=0
	endif
	if %option_1="1" then 'Significance signal test.
		check4=1
	endif
	if %option_2="1" then 'Periodogram components.
		check1=1
	endif
	if %option_3="1" then' Log scale.
		check5=1
	endif
	if %cycles_prob<>"" then  'P-value or maximun cycles.
		%max_p_value=%cycles_prob
	endif
	if %option_4="1" then 'Weighted Cycle by default.
		check7=0
	endif
	if %option_6="1" then 'Cycle sum by default.
		check6=2
	endif
	scalar choice ' Create the scalar in case when some line command arguments were introduced.
	
endif

'Minimum input requirements for the program, if not satisfied will stop running.

if %truncation_="" then
	@uiprompt("You must enter a truncation value")
	delete check1 check2 check3 check4 check5 check6 check7 choice
	stop
endif

if @val(%truncation_)<=0 then
	@uiprompt("The truncation must be positive")
	delete check1 check2 check3 check4 check5 check6 check7 choice
	stop
endif

if %name="" then
	@uiprompt("Please enter a series object")
	delete check1 check2 check3 check4 check5 check6 check7 choice
	stop
endif

if @val(%truncation_)>@obs({%name})/2 then ' The truncation point should not be too large.
	@uiprompt("The truncation is too large, please try a smaller one")
	delete check1 check2 check3 check4 check5 check6 check7 choice
	stop
endif

if @val(%max_p_value)<0 then 
	@uiprompt("Please enter a valid selection criteria (P-value or maximum number of cycles)")
	delete check1 check2 check3 check4 check5 check6 check7 choice
	stop
endif

if @val(%max_p_value)>@obs({%name})/2 then 'The maximum number of cycles is N/2.
	@uiprompt("The number of cycles is too large, please try a smaller one")
	delete check1 check2 check3 check4 check5 check6 check7 choice
	stop
endif

'----------------------------------------------------------------- PERIODOGRAM -------------------------------------------------------------
' Zt=Sum(k=0)(n/2) (Ak*Cos(Wk*t)+Bk*Sin(Wk*t))  - Fourier representation.
'Where Wk=2*p*k/n for k=0,1,...,n/2 - Fourier frequencys (angular).
' Estimators of the Fourier coefficients
'Ak=(1/n)*Sum (t=1)(n) Zt*Cos(Wk*t)  for k=0 and k=n/2 if n is even
'Ak=(2/n)*Sum (t=1)(n) Zt*Cos(Wk*t)  for k=1,2,...,(n-1)/2
'Bk=(2/n)*Sum (t=1)(n) Zt*Sin(Wk*t)  for k=1,2,...,(n-1)/2
'------------------------------------------------------------------------------------------------------------------------------------------------------

genr series1={%name}-@mean({%name}) 'Series object with zero mean.
stom(series1,series) 'Vector object.
scalar pi=@acos(-1)
scalar n=@obs(series) 'Observations.

'Fourier frequencys
for !i=1 to @floor(n/2) ' The zero frequency is ommited, the loop goes to @floor(n/2) in case of n odd.
	scalar q=!i
	if !i=@floor(n/2) and n/2<>@floor(n/2) then 'In case of n odd q will go to (n-1)/2
		q=(n-1)/2
	endif
	vector(@floor(n/2),1) w(!i,1)=(2*pi*q)/n 'w=2*pi*f angular frequency
	vector(@floor(n/2),1) frec(!i,1)=w(!i,1)/(2*pi) 
next

'Cosine matrix for A and Sine matrix for B
for !j=1 to @floor(n/2) ' jth frequency
	for !i=1 to n ' time
		if !j=@floor(n/2) and n/2=@floor(n/2) then ' In case of n even and the nyquist frequency.
			matrix(@floor(n/2),n) cosine(!j,!i)=1/n*(@cos(w(!j,1)*!i))
		else
			matrix(@floor(n/2),n) cosine(!j,!i)=2/n*(@cos(w(!j,1)*!i))
			matrix(@floor(n/2),n) sine(!j,!i)=2/n*(@sin(w(!j,1)*!i))
		endif
	next
next

'Fourier Coefficients
for !i=1 to @floor(n/2) ' ith coefficient
	vector AA=@rowextract(cosine,!i)*series
	vector(@floor(n/2),1) A(!i,1)=AA(1,1)
	vector BB=@rowextract(sine,!i)*series
	vector(@floor(n/2),1) B(!i,1)=BB(1,1)
next

mtos(frec,frequency) 'Series object.
mtos(w,ww) 'Series object.
mtos(A,estimated_a) 'Series object.
mtos(B,estimated_b) 'Series object.
genr periodogram=@sqrt(estimated_a^2+estimated_b^2) 'Estimated periodogram.
stom(periodogram,periodogram1) 'Vector object.


'------------------------------------------------------------- Outputs Graphs-----------------------------------------------------------

%grafico_a = "Periodogram_a" 'This type of command would be used for generating a new name if the object already exists.
if @isobject(%grafico_a) then 
	%grafico_a = @getnextname(%grafico_a)
endif

%grafico_b= "Periodogram_b"
if @isobject(%grafico_b) then 
	%grafico_b= @getnextname(%grafico_b)
endif

if check1=1 then 'If periodogram components were requested.
	group grafica_a frequency estimated_a
	freeze({%grafico_a}) grafica_a.xypair
	{%grafico_a}.axis(bottom) -invert range(minmax)
	{%grafico_a}.addtext(t) A component on {%name}
	group grafica_b frequency estimated_b
	freeze({%grafico_b}) grafica_b.xypair
	{%grafico_b}.axis(bottom) -invert range(minmax)
	{%grafico_b}.addtext(t) B component on {%name}
	delete grafica_a grafica_b
endif

%grafico = "Periodogram"
if @isobject(%grafico) then 
	%grafico = @getnextname(%grafico)
endif

if check2=1 then 'If unwindowed periodogram was requested.
	if check5=1 then 'If log scale was requested.
		group grafica frequency @log(periodogram)
		freeze({%grafico}) grafica.xypair
		scalar snr=@abs(@mean(@log(periodogram))/@stdev(@log(periodogram))) 'Signal to noise ratio.
		%snr=@left(@str(snr),4)
		{%grafico}.axis(bottom) -invert range(minmax)
		{%grafico}.addtext(t) Log Periodogram on {%name} l SNR:{%snr}
		delete grafica snr
	else
		group grafica frequency periodogram
		scalar snr=@mean(periodogram)/@stdev(periodogram)
		%snr=@left(@str(snr),4)
		freeze({%grafico}) grafica.xyarea
		{%grafico}.axis(bottom) -invert range(minmax)
		{%grafico}.addtext(t) Periodogram on {%name} l SNR:{%snr}
		delete grafica snr
	endif
endif

'------------------------------------------------- Smoothed Spectrum Graphs------------------------------------------------

%grafico_hamming= "Periodogram_Hamming"
if @isobject(%grafico_hamming) then 
	%grafico_hamming= @getnextname(%grafico_hamming)
endif

if check2=2 then 'If spectral density was calculated with Hamming window.
	series hamming_smooth
	call hamming(@val(%truncation_),periodogram,ww,hamming_smooth) 'Hamming subroutine at the end of the program.
	if check5=1 then 'If log scale was requested.
		group g_hamming frequency @log(hamming_smooth)
		freeze({%grafico_hamming}) g_hamming.xypair
		scalar snr=@abs(@mean(@log(hamming_smooth))/@stdev(@log(hamming_smooth)))
		%snr=@left(@str(snr),4)
		{%grafico_hamming}.axis(bottom) -invert range(minmax)
		{%grafico_hamming}.addtext(t) Kernel Density on {%name} | Hamming Window (Truncation: {%truncation_}) l SNR:{%snr}
		delete g_hamming snr
	else
		group g_hamming frequency hamming_smooth
		freeze({%grafico_hamming}) g_hamming.xyarea
		scalar snr=@mean(hamming_smooth)/@stdev(hamming_smooth)
		%snr=@left(@str(snr),4)
		{%grafico_hamming}.axis(bottom) -invert range(minmax)
		{%grafico_hamming}.addtext(t) Kernel Density on {%name} | Hamming Window (Truncation: {%truncation_}) l SNR:{%snr}
		delete g_hamming snr
	endif
endif

%grafico_hann= "Periodogram_Hann"
if @isobject(%grafico_hann) then 
	%grafico_hann= @getnextname(%grafico_hann)
endif

if check2=3 then  ' If spectral density was calculated with Hann window.
	series hann_smooth
	call hann(@val(%truncation_),periodogram,ww,hann_smooth) 'Hann subroutine at the end of the program.
	if check5=1 then  'If log scale was requested.
		group g_hann frequency @log(hann_smooth)
		freeze({%grafico_hann}) g_hann.xypair
		scalar snr=@abs(@mean(@log(hann_smooth))/@stdev(@log(hann_smooth)))
		%snr=@left(@str(snr),4)
		{%grafico_hann}.axis(bottom) -invert range(minmax)
		{%grafico_hann}.addtext(t) Kernel Density on {%name} | Hann Window (Truncation: {%truncation_}) l SNR:{%snr}
		delete g_hann snr
	else
		group g_hann frequency hann_smooth
		freeze({%grafico_hann}) g_hann.xyarea
		scalar snr=@mean(hann_smooth)/@stdev(hann_smooth)
		%snr=@left(@str(snr),4)
		{%grafico_hann}.axis(bottom) -invert range(minmax)
		{%grafico_hann}.addtext(t) Kernel Density on {%name} | Hann Window (Truncation: {%truncation_}) l SNR:{%snr}
		delete g_hann snr
	endif
endif

%grafico_bartlett= "Periodogram_bartlett"
if @isobject(%grafico_bartlett) then 
	%grafico_bartlett= @getnextname(%grafico_bartlett)
endif

if check2=4 then ' If spectral density was calculated with Bartlett window.
	series bartlett_smooth
	call bartlett(@val(%truncation_),periodogram,ww,bartlett_smooth)  'Bartlett subroutine at the end of the program.
	if check5=1 then 'If log scale was requested.
		group g_bartlett frequency @log(bartlett_smooth)
		freeze({%grafico_bartlett}) g_bartlett.xypair
		scalar snr=@abs(@mean(@log(bartlett_smooth))/@stdev(@log(bartlett_smooth)))
		%snr=@left(@str(snr),4)
		{%grafico_bartlett}.axis(bottom) -invert range(minmax)   
		{%grafico_bartlett}.addtext(t) Kernel Density on {%name} | Bartlett Window (Truncation: {%truncation_}) l SNR:{%snr}
		delete g_bartlett snr
	else
		group g_bartlett frequency bartlett_smooth
		freeze({%grafico_bartlett}) g_bartlett.xyarea
		scalar snr=@mean(bartlett_smooth)/@stdev(bartlett_smooth)
		%snr=@left(@str(snr),4)
		{%grafico_bartlett}.axis(bottom) -invert range(minmax)   
		{%grafico_bartlett}.addtext(t) Kernel Density on {%name} | Bartlett Window (Truncation: {%truncation_}) l SNR:{%snr}
		delete g_bartlett snr
	endif
endif

%grafico_parzen= "Periodogram_parzen"
if @isobject(%grafico_parzen) then 
	%grafico_parzen= @getnextname(%grafico_parzen)
endif

if check2=5 then ' If spectral density was calculated with Parzen window.
	series parzen_smooth
	call parzen(@val(%truncation_),periodogram,ww,parzen_smooth)  'Parzen subroutine at the end of the program.
	if check5=1 then 'If log scale was requested.
		group g_parzen frequency @log(parzen_smooth)
		freeze({%grafico_parzen}) g_parzen.xypair
		scalar snr=@abs(@mean(@log(parzen_smooth))/@stdev(@log(parzen_smooth)))
		%snr=@left(@str(snr),4)
		{%grafico_parzen}.axis(bottom) -invert range(minmax)   
		{%grafico_parzen}.addtext(t) Kernel Density on {%name} | Parzen Window (Truncation: {%truncation_}) l SNR:{%snr}
		delete g_parzen snr
	else
		group g_parzen frequency parzen_smooth
		freeze({%grafico_parzen}) g_parzen.xyarea
		scalar snr=@mean(parzen_smooth)/@stdev(parzen_smooth)
		%snr=@left(@str(snr),4)
		{%grafico_parzen}.axis(bottom) -invert range(minmax)   
		{%grafico_parzen}.addtext(t) Kernel Density on {%name} | Parzen Window (Truncation: {%truncation_}) l SNR:{%snr}
		delete g_parzen snr
	endif
endif

%grafico_truncated= "Periodogram_truncated"
if @isobject(%grafico_truncated) then 
	%grafico_truncated= @getnextname(%grafico_truncated)
endif

if check2=6 then ' If spectral density was calculated with Truncated window.
	series truncated_smooth
	call truncated(@val(%truncation_),periodogram,ww,truncated_smooth) 'Truncated subroutine at the end of the program.
	if check5=1 then 'If log scale was requested.
		group g_truncated frequency @log(truncated_smooth)
		freeze({%grafico_truncated}) g_truncated.xypair
		scalar snr=@abs(@mean(@log(truncated_smooth))/@stdev(@log(truncated_smooth)))
		%snr=@left(@str(snr),4)
		{%grafico_truncated}.axis(bottom) -invert range(minmax)   
		{%grafico_truncated}.addtext(t) Kernel Density on {%name} | Truncated Window (Truncation: {%truncation_}) l SNR:{%snr}
		delete g_truncated snr
	else
		group g_truncated frequency truncated_smooth
		freeze({%grafico_truncated}) g_truncated.xyarea
		scalar snr=@mean(truncated_smooth)/@stdev(truncated_smooth)
		%snr=@left(@str(snr),4)
		{%grafico_truncated}.axis(bottom) -invert range(minmax)   
		{%grafico_truncated}.addtext(t) Kernel Density on {%name} | Truncated Window (Truncation: {%truncation_}) l SNR:{%snr}
		delete g_truncated snr
	endif
endif

%grafico_daniell= "Periodogram_daniell"
if @isobject(%grafico_daniell) then 
	%grafico_daniell=@getnextname(%grafico_daniell)
endif

if check2=7 then ' If spectral density was calculated with Daniell window.
	series daniell_smooth
	call daniell(@val(%truncation_),periodogram,ww,daniell_smooth) 'Daniell subroutine at the end of the program.
	if check5=1 then 'If log scale was requested.
		group g_daniell frequency @log(daniell_smooth)
		freeze({%grafico_daniell}) g_daniell.xypair
		scalar snr=@abs(@mean(@log(daniell_smooth))/@stdev(@log(daniell_smooth)))
		%snr=@left(@str(snr),4)
		{%grafico_daniell}.axis(bottom) -invert range(minmax)   
		{%grafico_daniell}.addtext(t) Kernel Density on {%name} | Daniell Window (Truncation: {%truncation_}) l SNR:{%snr}
		delete g_daniell snr
	else
		group g_daniell frequency daniell_smooth
		freeze({%grafico_daniell}) g_daniell.xyarea
		scalar snr=@mean(daniell_smooth)/@stdev(daniell_smooth)
		%snr=@left(@str(snr),4)
		{%grafico_daniell}.axis(bottom) -invert range(minmax)   
		{%grafico_daniell}.addtext(t) Kernel Density on {%name} | Daniell Window (Truncation: {%truncation_}) l SNR:{%snr}
		delete g_daniell snr
	endif
endif

%grafico_priestley= "Periodogram_Priestley"
if @isobject(%grafico_priestley) then 
	%grafico_priestley=@getnextname(%grafico_priestley)
endif

if check2=8 then ' If spectral density was calculated with Priestley window.
	series priestley_smooth
	call priestley(@val(%truncation_),periodogram,ww,priestley_smooth) 'Priestley subroutine at the end of the program.
	if check5=1 then 'If log scale was requested.
		group g_priestley frequency @log(priestley_smooth)
		freeze({%grafico_priestley}) g_priestley.xypair
		scalar snr=@abs(@mean(@log(priestley_smooth))/@stdev(@log(priestley_smooth)))
		%snr=@left(@str(snr),4)
		{%grafico_priestley}.axis(bottom) -invert range(minmax)   
		{%grafico_priestley}.addtext(t) Kernel Density on {%name} | Bartlett-Priestley Window (Truncation: {%truncation_}) l SNR:{%snr}
		delete g_priestley snr
	else
		group g_priestley frequency priestley_smooth
		freeze({%grafico_priestley}) g_priestley.xyarea
		scalar snr=@mean(priestley_smooth)/@stdev(priestley_smooth)
		%snr=@left(@str(snr),4)
		{%grafico_priestley}.axis(bottom) -invert range(minmax)   
		{%grafico_priestley}.addtext(t) Kernel Density on {%name} | Bartlett-Priestley Window (Truncation: {%truncation_}) l SNR:{%snr}
		delete g_priestley snr
	endif
endif

'--------------------------------------------------------------- Output Table------------------------------------------------------------

if check3=1 then 'If ouput table was requested.
	
	%table="data"
	if @isobject(%table) then 
		%table= @getnextname(%table)
	endif
	
	table(@floor(n/2)+2) {%table}
	{%table}(1,1)="Angular Frequency (Omega)" 'First three columns.
	{%table}(1,2)="Frequency (Cycle/Time Unit)"
	{%table}(1,3)="Cycle Frequency (Time Unit/Cycle)"
	
	if check1=1 then ' If periodogram components were requested these will be placed at the end of the table (columns 5 and 6).
		for !i=1 to @floor(n/2)
			{%table}(1,5)="Estimated A"
			{%table}(!i+1,5)=A(!i,1)
			{%table}(1,6)="Estimated B"
			{%table}(!i+1,6)=B(!i,1)
		next
	endif
	
	for !i=1 to @floor(n/2)
		{%table}(!i+1,1)=w(!i,1)  'First three columns.
		{%table}(!i+1,2)=frec(!i,1)
		{%table}(!i+1,3)=1/frec(!i,1)
		if check5=1 then 'Log scale.
			if check2=1 then 'Periodogram.
				{%table}(!i+1,4)=@log(periodogram1(!i,1))
				{%table}(1,4)="Log Periodogram"
			endif
			if check2=2 then 'Hamming.
				stom(hamming_smooth,hamming_smooth1)
				{%table}(!i+1,4)=@log(hamming_smooth1(!i,1))
				{%table}(1,4)="Log Spectral Density | Hamming"
				delete hamming_smooth1
			endif
			if check2=3 then 'Hann.
				stom(hann_smooth,hann_smooth1)
				{%table}(!i+1,4)=@log(hann_smooth1(!i,1))
				{%table}(1,4)="Log Spectral Density | Hann"
				delete hann_smooth1
			endif
			if check2=4 then 'Bartlett.
				stom(bartlett_smooth,bartlett_smooth1)
				{%table}(!i+1,4)=@log(bartlett_smooth1(!i,1))
				{%table}(1,4)="Log Spectral Density | Bartlett"
				delete bartlett_smooth1
			endif
			if check2=5 then 'Parzen.
				stom(parzen_smooth,parzen_smooth1)
				{%table}(!i+1,4)=@log(parzen_smooth1(!i,1))
				{%table}(1,4)="Log Spectral Density | Parzen"
				delete parzen_smooth1
			endif
			if check2=6 then 'Truncated.
				stom(truncated_smooth,truncated_smooth1)
				{%table}(!i+1,4)=@log(truncated_smooth1(!i,1))
				{%table}(1,4)="Log Spectral Density | Truncated"
				delete truncated_smooth1
			endif
			if check2=7 then 'Daniell.
				stom(daniell_smooth,daniell_smooth1)
				{%table}(!i+1,4)=@log(daniell_smooth1(!i,1))
				{%table}(1,4)="Log Spectral Density | Daniell"
				delete daniell_smooth1
			endif
			if check2=8 then 'Priestley.
				stom(priestley_smooth,priestley_smooth1)
				{%table}(!i+1,4)=@log(priestley_smooth1(!i,1))
				{%table}(1,4)="Log Spectral Density | Bartlett-Priestley"
				delete priestley_smooth1
			endif
		else 'No log scale.
			if check2=1 then 'Periodogram.
				{%table}(!i+1,4)=periodogram1(!i,1)
				{%table}(1,4)="Periodogram"
			endif
			if check2=2 then 'Hamming.
				stom(hamming_smooth,hamming_smooth1)
				{%table}(!i+1,4)=hamming_smooth1(!i,1)
				{%table}(1,4)="Spectral Density | Hamming"
				delete hamming_smooth1
			endif
			if check2=3 then 'Hann.
				stom(hann_smooth,hann_smooth1)
				{%table}(!i+1,4)=hann_smooth1(!i,1)
				{%table}(1,4)="Spectral Density | Hann"
				delete hann_smooth1
			endif
			if check2=4 then 'Bartlett.
				stom(bartlett_smooth,bartlett_smooth1)
				{%table}(!i+1,4)=bartlett_smooth1(!i,1)
				{%table}(1,4)="Spectral Density | Bartlett"
				delete bartlett_smooth1
			endif
			if check2=5 then 'Parzen.
				stom(parzen_smooth,parzen_smooth1)
				{%table}(!i+1,4)=parzen_smooth1(!i,1)
				{%table}(1,4)="Spectral Density | Parzen"
				delete parzen_smooth1
			endif
			if check2=6 then 'Truncated.
				stom(truncated_smooth,truncated_smooth1)
				{%table}(!i+1,4)=truncated_smooth1(!i,1)
				{%table}(1,4)="Spectral Density | Truncated"
				delete truncated_smooth1
			endif
			if check2=7 then 'Daniell.
				stom(daniell_smooth,daniell_smooth1)
				{%table}(!i+1,4)=daniell_smooth1(!i,1)
				{%table}(1,4)="Spectral Density | Daniell"
				delete daniell_smooth1
			endif
			if check2=8 then 'Priestley.
				stom(priestley_smooth,priestley_smooth1)
				{%table}(!i+1,4)=priestley_smooth1(!i,1)
				{%table}(1,4)="Spectral Density | Bartlett-Priestley"
				delete priestley_smooth1
			endif
		endif
	next
	
	{%table}.setwidth(@all) 28
	{%table}.setheight(1) 2
	{%table}.setfillcolor(1) @rgb(9, 79, 164)
	{%table}.settextcolor(1) white
	{%table}.setlines(@all) +a
	{%table}.label(r) Author of the program: Nicolas Ronderos Pulido.
	
endif

'---------------------------------------------------------- Confidence Intervals and Tests---------------------------------------------------------

'-----------Confidence intervals for spectral density----------
'Confidence interval:
' (V*f(w)/Chi2(a/2)(V)) <= f(w) <= (V*f(w)/Chi2(1-a/2)(V))   f(w) is the estimated density
'Confidence interval of the log spectral density:
'ln(f(w))+ln(V/Chi2(a/2)(V) <= ln(f(w)) <= ln(f(w))+ln(V/Chi2(1-a/2)(V)
' Equivalent degrees of fredom
'----------------------------------------
' Window                     V
'----------------------------------------
'Hamming          2.5164(N/M)
'Hann                      8N/3M
'Bartlett                     3N/M
'Parzen             3.708614(N/M)
'Truncated                N/M
'Daniell                    2N/M
'Priestley               1.4(N/M)
'----------------------------------------

if check2=2 then 'Hamming.
	if check5=1 then 'Log scale.
		genr u_ic=@log(hamming_smooth)+@log((2.5164*n/@val(%truncation_))/@qchisq(1-0.975,(2.5164*n/@val(%truncation_)))) 'Upper IC at 95% of confidence.
		genr l_ic=@log(hamming_smooth)+@log((2.5164*n/@val(%truncation_))/@qchisq(0.975,(2.5164*n/@val(%truncation_)))) 'Lower IC at 95% of confidence.
		genr smooth=@log(hamming_smooth)
	else 'No log scale.
		genr u_ic=(2.516*n/@val(%truncation_))*hamming_smooth/@qchisq(1-0.975,(2.5164*n/@val(%truncation_))) 'Upper IC at 95% of confidence.
		genr l_ic=(2.516*n/@val(%truncation_))*hamming_smooth/@qchisq(0.975,(2.5164*n/@val(%truncation_)))  'Lower IC at 95% of confidence.
		genr smooth=hamming_smooth
	endif
	delete hamming_smooth
endif

if check2=3 then 'Hann.
	if check5=1 then 'Log scale.
		genr u_ic=@log(hann_smooth)+@log((8*n/(3*@val(%truncation_)))/@qchisq(1-0.975,(8*n/(3*@val(%truncation_))))) 'Upper IC at 95% of confidence.
		genr l_ic=@log(hann_smooth)+@log((8*n/(3*@val(%truncation_)))/@qchisq(0.975,(8*n/(3*@val(%truncation_))))) 'Lower IC at 95% of confidence.
		genr smooth=@log(hann_smooth)
	else'No log scale.
		genr u_ic=(8*n/(3*@val(%truncation_)))*hann_smooth/@qchisq(1-0.975,(8*n/(3*@val(%truncation_)))) 'Upper IC at 95% of confidence.
		genr l_ic=(8*n/(3*@val(%truncation_)))*hann_smooth/@qchisq(0.975,(8*n/(3*@val(%truncation_))))  'Lower IC at 95% of confidence.
		genr smooth=hann_smooth
	endif
	delete hann_smooth
endif

if check2=4 then 'Bartlett.
	if check5=1 then 'Log scale.
		genr u_ic=@log(bartlett_smooth)+@log((3*n/@val(%truncation_))/@qchisq(1-0.975,(3*n/@val(%truncation_))))  'Upper IC at 95% of confidence.
		genr l_ic=@log(bartlett_smooth)+@log((3*n/@val(%truncation_))/@qchisq(0.975,(3*n/@val(%truncation_))))  'Lower IC at 95% of confidence.
		genr smooth=@log(bartlett_smooth)
	else 'No log scale.
		genr u_ic=(3*n/@val(%truncation_))*bartlett_smooth/@qchisq(1-0.975,(3*n/@val(%truncation_))) 'Upper IC at 95% of confidence.
		genr l_ic=(3*n/@val(%truncation_))*bartlett_smooth/@qchisq(0.975,(3*n/@val(%truncation_)))  'Lower IC at 95% of confidence.
		genr smooth=bartlett_smooth
	endif
	delete bartlett_smooth
endif

if check2=5 then 'Parzen.
	if check5=1 then 'Log scale.
		genr u_ic=@log(parzen_smooth)+@log((3.709*n/@val(%truncation_))/@qchisq(1-0.975,(3.709*n/@val(%truncation_)))) 'Upper IC at 95% of confidence.
		genr l_ic=@log(parzen_smooth)+@log((3.709*n/@val(%truncation_))/@qchisq(0.975,(3.709*n/@val(%truncation_))))  'Lower IC at 95% of confidence.
		genr smooth=@log(parzen_smooth)
	else 'No log scale.
		genr u_ic=(3.709*n/@val(%truncation_))*parzen_smooth/@qchisq(1-0.975,(3.709*n/@val(%truncation_))) 'Upper IC at 95% of confidence.
		genr l_ic=(3.709*n/@val(%truncation_))*parzen_smooth/@qchisq(0.975,(3.709*n/@val(%truncation_)))  'Lower IC at 95% of confidence.
		genr smooth=parzen_smooth
	endif
	delete parzen_smooth
endif

if check2=6 then 'Truncated.
	if check5=1 then 'Log scale.
		genr u_ic=@log(truncated_smooth)+@log((n/@val(%truncation_))/@qchisq(1-0.975,(n/@val(%truncation_))))  'Upper IC at 95% of confidence.
		genr l_ic=@log(truncated_smooth)+@log((n/@val(%truncation_))/@qchisq(0.975,(n/@val(%truncation_))))  'Lower IC at 95% of confidence.
		genr smooth=@log(truncated_smooth)
	else 'No log scale.
		genr u_ic=(n/@val(%truncation_))*truncated_smooth/@qchisq(1-0.975,(n/@val(%truncation_))) 'Upper IC at 95% of confidence.
		genr l_ic=(n/@val(%truncation_))*truncated_smooth/@qchisq(0.975,(n/@val(%truncation_)))  'Lower IC at 95% of confidence.
		genr smooth=truncated_smooth
	endif
	delete truncated_smooth
endif

if check2=7 then 'Daniell.
	if check5=1 then 'Log scale.
		genr u_ic=@log(daniell_smooth)+@log((2*n/@val(%truncation_))/@qchisq(1-0.975,(n/@val(%truncation_)))) 'Upper IC at 95% of confidence.
		genr l_ic=@log(daniell_smooth)+@log((2*n/@val(%truncation_))/@qchisq(0.975,(n/@val(%truncation_))))   'Lower IC at 95% of confidence.
		genr smooth=@log(daniell_smooth)
	else 'No log scale.
		genr u_ic=(2*n/@val(%truncation_))*daniell_smooth/@qchisq(1-0.975,2*n/@val(%truncation_)) 'Upper IC at 95% of confidence.
		genr l_ic=(2*n/@val(%truncation_))*daniell_smooth/@qchisq(0.975,2*n/@val(%truncation_))  'Lower IC at 95% of confidence.
		genr smooth=daniell_smooth
	endif
	delete daniell_smooth
endif

if check2=8 then 'Priestley.
	if check5=1 then 'Log scale.
		genr u_ic=@log(priestley_smooth)+@log((2*n/@val(%truncation_))/@qchisq(1-0.975,(n/@val(%truncation_)))) 'Upper IC at 95% of confidence.
		genr l_ic=@log(priestley_smooth)+@log((2*n/@val(%truncation_))/@qchisq(0.975,(n/@val(%truncation_))))  'Lower IC at 95% of confidence.
		genr smooth=@log(priestley_smooth)
	else 'No log scale.
		genr u_ic=(1.4*n/@val(%truncation_))*priestley_smooth/@qchisq(1-0.975,2*n/@val(%truncation_)) 'Upper IC at 95% of confidence.
		genr l_ic=(1.4*n/@val(%truncation_))*priestley_smooth/@qchisq(0.975,2*n/@val(%truncation_))  'Lower IC at 95% of confidence.
		genr smooth=priestley_smooth
	endif
	delete priestley_smooth
endif

if check4=1 then 'If the significance signal test were requested.
	
	%spool="Signal_Tests" 'Spool for saving the tests results.
	if @isobject(%spool) then
		%spool=@getnextname(%spool)
	endif
	spool {%spool}
	{%spool}.options tree borders comments margins
	
	'------------------------------------Wei (1994) test------------------------------------
	
	series statistical
	series p_value
	call test_signal(periodogram,statistical,p_value,n) 'Test signal subroutine at the end of the program.
	%test_signal1= "Test_Signal1"
	group test1 frequency p_value statistical ' To graph Wei test.
	freeze({%test_signal1}) test1.xypair
	{%test_signal1}.axis(bottom) -invert range(minmax)   
	{%test_signal1}.setelem(3) axis(r)
	{%test_signal1}.addtext(t) P-value VS Frequency on {%name} (H0: The periodogram ordinate is not significant enough)
	{%test_signal1}.name(2) P-Value
	{%test_signal1}.name(3) Test Statistic
	{%test_signal1}.legend position(bc)
	
	'---------------------------Whittle (1952) and Fisher (1929) test--------------------------------
	'--------Fisher Test---------
	'T=I1(Wk)/Sum(k=1)(n/2) I(Wk)   --- Statistic, where I1(Wk)=Max(I(Wk))
	'Pr(T>g) = a = N(1-g)^(N-1)  --- Where g is the critical value,a is the significance level and N=n/2
	'g=1-(a/N)^(1/(N-1))
	'--------Whittle Test---------
	'T2=I2(Wk)/(Sum(k=1)(n/2) I(Wk)-I1(Wk)) ' Where I2(Wk) is the second maximum
	'Pr(T>g) = a = N(1-g)^(N-1)  --- Where g is the critical value,a is the significance level and N=(n/2)-1
	'g=1-(a/N)^(1/(N-1))
	'--------------------------------------------------------------------------------------------------------------
	
	genr ranks=@ranks(periodogram,"a","i") 'The ranks will be used for identifing the lower order maximums, ties are ignored.
	stom(ranks,ranks1)
	scalar tested=0 'To save the already tested ordinates.
	vector(@floor(n/2),1) critical=NA ' To save critical values
	'----------------------------------Fisher test-------------------------------------------
	for !j=1 to @floor(n/2) 
		if @floor(n/2)=ranks1(!j) then 'To find the jth coordinates of the maximum.
			vector(@floor(n/2),1) T(!j,1)=periodogram1(!j)/@sum(periodogram1) 'The statistical will be saved in the jth coordinate of the T vector.
			tested=periodogram1(!j)
			critical(!j)=1-(0.05/(@floor(n/2)))^(1/(@floor(n/2)-1))  'Significance level: a=5%.
		endif
	next
	'---------------------------------Whittle test--------------------------------------------
	for !i=1 to @floor(n/2)-2 'Critical value canot be computed for N or N-1 (Two NA in critical value).
		for !j=1 to @floor(n/2) 'To find the i-1th maximum using the jth coordinate.
			if @floor(n/2)-!i=ranks1(!j) then 'If the i-1th maximum coordinate is found.
				vector(@floor(n/2),1) T(!j,1)=periodogram1(!j)/(@sum(periodogram1)-tested)  'The statistical will be saved in the jth coordinate of the T vector.
				tested=periodogram1(!j)+tested
				critical(!j)=1-(0.05/(@floor(n/2)-!i))^(1/(@floor(n/2)-!i-1)) 'Significance level: a=5%.
			endif
		next
	next
	mtos(T,t_statistic)
	mtos(critical,critical_v)
	
	%test_signal2= "Test_Signal2"
	group test2 frequency t_statistic-critical_v 'To graph the Fisher and Whittle test.
	freeze({%test_signal2}) test2.xypair
	{%test_signal2}.axis(bottom) -invert range(minmax)
	{%test_signal2}.addtext(t) T Statistic - Critical Value VS Frequency on {%name} (H0: The periodogram ordinate is not significant enough)
	{%test_signal2}.name(2) T Statistic - Critical Value
	
	'---------------------Confidence intervals for spectral density------------------
	
	%table1="Test_Data" ' Table to tabulate the tests results.
	if check2=2 or check2=3 or check2=4 or check2=5 or check2=6 or check2=7 or check2=8 then 'If a smoothed spectra was requested locate the confidence interval at the end of the table (columns 6 and 7).
		table(@floor(n/2),10) {%table1} 'Two more columns in the table for the confidence intervals.
		%test_signal3= "Test_Signal3"
		group test3 frequency smooth frequency u_ic frequency l_ic 'To graph the spectral density confidence intervals.
		freeze({%test_signal3}) test3.xypair
		{%test_signal3}.axis(bottom) -invert range(minmax)
		{%test_signal3}.addtext(t) IC (95%) l Smoothed Spectrum of {%name}
		{%test_signal3}.legend -display
		{%test_signal3}.setelem(2) lcolor(red) lpat(dash6)
		{%test_signal3}.setelem(3) lcolor(red) lpat(dash6)
	else 'No spectral density requested.
		table(@floor(n/2),8) {%table1}
	endif
	
	'----------------------------------Bartlett (1954) test---------------------------------
	
	series uu
	series ll_ic
	series uu_ic
	call bartlett_test(periodogram,uu,ll_ic,uu_ic) 'Bartlett test subroutine at the end of the program.
	%test_signal4="Test_Signal4"
	group test4 frequency uu frequency ll_ic frequency uu_ic 'To graph the Bartlett test.
	freeze({%test_signal4}) test4.xypair
	{%test_signal4}.axis(bottom) -invert range(minmax)   
	{%test_signal4}.addtext(t)  Normalized Integrated spectrum VS Frequency on {%name} (H0: The observations come from a white noise process)
	{%test_signal4}.legend position(bc)
	{%test_signal4}.setelem(3) lcolor(red)
	{%test_signal4}.legend -display
	
	'-------------------------------------Table tests-----------------------------------------
	
	{%table1}(1,1)="Angular Frequency (Omega)"
	{%table1}(1,2)="Statistical l Wei (1994)"
	{%table1}(1,3)="P-value l Wei (1994)"
	{%table1}(1,4)="Statistical l Whittle (1952) and Fisher (1929)"
	{%table1}(1,5)="Critical value l Whittle (1952) and Fisher (1929)"
	{%table1}(1,6)="Normalized Integrated Spectrum l Bartlett (1954)"
	{%table1}(1,7)="Upper IC 95% l Bartlett (1954)"
	{%table1}(1,8)="Lower IC 95% l Bartlett (1954)"
	
	stom(statistical,statistical_wei) 'Vector objects.
	stom(p_value,p_value_wei)
	stom(uu,uu_)
	stom(uu_ic,uu_ic_)
	stom(ll_ic,ll_ic_)
	
	for !i=1 to @floor(n/2) 'To copy the data to the table.
		{%table1}(!i+1,1)=w(!i,1)
		{%table1}(!i+1,2)=statistical_wei(!i)
		{%table1}(!i+1,3)=p_value_wei(!i)
		{%table1}(!i+1,4)=t(!i)
		{%table1}(!i+1,5)=critical(!i)
		{%table1}(!i+1,6)=uu_(!i)
		{%table1}(!i+1,7)=uu_ic_(!i)
		{%table1}(!i+1,8)=ll_ic_(!i)
		if check2=2 or check2=3 or check2=4 or check2=5 or check2=6 or check2=7 or check2=8 then 'If spectral density was requested.
			stom(u_ic,u_ic_) 'Vector objects.
			stom(l_ic,l_ic_)
			{%table1}(1,9)="Upper IC 95% l Priestley (1981)"
			{%table1}(1,10)="Lower IC 95% l Priestley (1981)"
			{%table1}(!i+1,9)=u_ic_(!i)
			{%table1}(!i+1,10)=l_ic_(!i)
			delete u_ic_ l_ic_
		endif
	next
	
	{%table1}.setwidth(@all) 42 'Arranging the table.
	{%table1}.setheight(1) 2
	{%table1}.setfillcolor(1) @rgb(9, 79, 164)
	{%table1}.settextcolor(1) white
	{%table1}.setlines(@all) +a
	{%table1}.label(r) Author of the program: Nicolas Ronderos Pulido.
	
	{%spool}.insert(name="Graph_1") {%test_signal1}
	{%spool}.comment "Graph_1" "Significance test signal graph l Wei (1994)"
	{%spool}.insert(name="Graph_2") {%test_signal2}
	{%spool}.comment "Graph_2" "Significance test signal graph l Whittle (1952) and Fisher (1929)\nSignificance level : 5%"
	{%spool}.insert(name="Graph_3") {%test_signal4}
	{%spool}.comment "Graph_3" "Significance test signal graph l Bartlett (1952) Confidence level : 95%"
	if check2=2 or check2=3 or check2=4 or check2=5 or check2=6 or check2=7 or check2=8 then
		{%spool}.insert(name="Graph_4") {%test_signal3}
		{%spool}.comment "Graph_4" "Confidence Interval (95%) l Priestley (1981)"
	endif
	{%spool}.insert(name="Data_Test") {%table1}
	{%spool}.comment "Data_Test" "Data Test"
	
	delete p_value statistical test1 ranks ranks1 t tested critical critical_v t_statistic test2 test_signal1 test_signal2 test_data ll_ic test4 test_signal4 uu uu_ic ll_ic_ p_value_wei statistical_wei uu_ uu_ic_
	
endif

if check2=2 or check2=3 or check2=4 or check2=5 or check2=6 or check2=7 or check2=8 then 'If spectral density was requested.
	delete u_ic l_ic smooth
	if check4=1 then '
		delete test_signal3 test3
	endif
endif
'---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
'--------------------------------------------------------------------------Spectral Filter------------------------------------------------------------------------------
'---------------------------------------------------------------------------------------------------------------------------------------------------------------------------

if %max_p_value<>"For example: 0.05 or 2" then ' If the user request the use of the filter.
	'---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	'-------------------------------------------------------------------P Value selection criteria----------------------------------------------------------------------
	'---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	if @val(%max_p_value)<1 and @val(%max_p_value)>0 then 'If the user request the p-value selection criteria.
		!prob=@val(%max_p_value)
		series statistical
		series p_value
		scalar sf_exist=0 'Check the existence of a p-value equal or less than requested.
		call test_signal(periodogram,statistical,p_value,n)
		vector(@obs(p_value),1) significant_frequencies=0
		stom(p_value,p_value_wei)
		
		for !i=1 to @obs(p_value_wei)
			if p_value_wei(!i)<=!prob then 
				significant_frequencies(!i,1)=frec(!i) 'Saves the significant fourier frequencys.
				sf_exist=sf_exist+1
			endif
		next
		
		if sf_exist=0 then 'Stop the program.
			delete a aa b bb check1 check2 check3 check4 check5 check6 check7 choice cosine estimated_a estimated_b frec frequency n p_value periodogram periodogram1 pi q sine series1 series sf_exist significant_frequencies statistical w ww
			@uiprompt("There is not any significant frequency at this probability level")
			stop
		endif
		
		%sfw__= "sf_wsum" 'Significant frequency cycle weighted sum.
		if @isobject(%sfw__) then 
			%sfw__= @getnextname(%sfw__)
		endif
		
		%sf__= "sf_sum" 'Significant frequency cycle sum.
		if @isobject(%sf__) then 
			%sf__= @getnextname(%sf__)
		endif
		
		'------------------------------------------------Weighted-----------------------------------------------------
		if check7=1 then 'Weighted.
			
			if check6=1 then 'Sum.
				series {%sfw__}=0
				for !i=1 to @obs(p_value_wei)
					if significant_frequencies(!i,1)<>0 then 'If the ith frequency is statistically significant.
						scalar sf_=significant_frequencies(!i,1)
						scalar sfw1_=A(!i,1)
						scalar sfw2_=B(!i,1)
						scalar ta=@dtoo(@word(@pagesmpl,1))-1
						{%sfw__}={%sfw__}+sfw1_*@cos(2*@acos(-1)*(@trend+1-ta)*sf_)+sfw2_*@sin(2*@acos(-1)*(@trend+1-ta)*sf_) 'Generate the weighted sum of significant ordinates of the periodogram.
					endif
				next
			endif
			
			if check6=2 then 'Individual.
				for !i=1 to @obs(p_value_wei)
					if significant_frequencies(!i,1)<>0 then  'If the ith frequency is statistically significant.
						scalar sf_=significant_frequencies(!i,1)
						scalar sfw1_=A(!i,1)
						scalar sfw2_=B(!i,1)
						scalar ta=@dtoo(@word(@pagesmpl,1))-1
						genr sfw_!i=sfw1_*@cos(2*@acos(-1)*(@trend+1-ta)*sf_)+sfw2_*@sin(2*@acos(-1)*(@trend+1-ta)*sf_) 'Generate the weighted individual cycles of significant ordinates of the periodogram.
					endif
				next
			endif
			
			delete p_value p_value_wei significant_frequencies statistical sf_ sfw1_ sfw2_ sf_exist ta
		else ' If the requested filter is not weighted.
			
			'---------------------------------------------------Unweighted-------------------------------------------
			
			if check6=1 then 'Sum.
				series {%sf__}=0
				for !i=1 to @obs(p_value)
					if significant_frequencies(!i,1)<>0 then 'If the ith frequency is statistically significant.
						scalar sf_=significant_frequencies(!i,1)
						scalar ta=@dtoo(@word(@pagesmpl,1))-1
						{%sf__}={%sf__}+@cos(2*@acos(-1)*(@trend+1-ta)*sf_)+@sin(2*@acos(-1)*(@trend+1-ta)*sf_) 'Generate the unweighted sum of significant ordinates of the periodogram.
					endif
				next
			endif
			
			if check6=2 then 'Individual.
				for !i=1 to @obs(p_value_wei)
					if significant_frequencies(!i,1)<>0 then 'If the ith frequency is statistically significant.
						scalar sf_=significant_frequencies(!i,1)
						scalar ta=@dtoo(@word(@pagesmpl,1))-1
						genr sf_!i=@cos(2*@acos(-1)*(@trend+1-ta)*sf_)+@sin(2*@acos(-1)*(@trend+1-ta)*sf_) 'Generate the unweighted individual cycles of significant ordinates of the periodogram.
					endif
				next
			endif
			
			delete p_value p_value_wei sf_ significant_frequencies statistical sf_exist ta
		endif
	endif
	'----------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	' ----------------------------------------------------------------------Maximum Cycle--------------------------------------------------------------------------------
	'----------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	if @val(%max_p_value)>=1 then
		!k=@val(%max_p_value)
		vector(!k,1) maximum1
		vector(!k,1) maximum2
		vector(!k,1) large_frequencies
		scalar max_rank=0
		genr ranks1=@ranks(periodogram,"a","i") 'The ranks will be used for identifing the maximums, ties are ignored.
		stom(ranks1,ranks)
		
		for !j=1 to !k
			if !j=1 then
				max_rank=@obs(periodogram)
			else
				max_rank=(@obs(periodogram))-!j+1
			endif
			for !i=1 to @obs(periodogram)
				if max_rank=ranks(!i) then 'To find the coordinate of the jth maximum with their weights and their frequency.
					maximum1(!j,1)=A(!i)
					maximum2(!j,1)=B(!i)
					large_frequencies(!j,1)=frec(!i)
				endif
			next
		next
		
		%fw__= "mf_wsum" 'Maximum weighted ordinate.
		if @isobject(%fw__) then 
			%fw__= @getnextname(%fw__)
		endif
		
		%f__= "mf_sum"  'Maximum unweighted ordinate.
		if @isobject(%f__) then 
			%f__= @getnextname(%f__)
		endif
		'-----------------------------------------------Weighted------------------------------------------------
		
		if check7=1 then 'Weighted.
			
			if check6=1 then 'Sum.
				series {%fw__}=0
				for !i=1 to !k
					scalar weight1=maximum1(!i,1)
					scalar weight2=maximum2(!i,1)
					scalar f_=large_frequencies(!i,1)
                           scalar ta=@dtoo(@word(@pagesmpl,1))-1
					{%fw__}= {%fw__}+weight1*@cos(2*@acos(-1)*(@trend+1-ta)*f_)+weight2*@sin(2*@acos(-1)*(@trend+1-ta)*f_)  'Generate the weighted sum of the maximum ordinates of the periodogram.
				next
			endif
			
			if check6=2 then 'Individual.
				for !i=1 to !k
					scalar weight1=maximum1(!i,1)
					scalar weight2=maximum2(!i,1)
					scalar f_=large_frequencies(!i,1)
					scalar ta=@dtoo(@word(@pagesmpl,1))-1
					genr f_w!i=weight1*@cos(2*@acos(-1)*(@trend+1-ta)*f_)+weight2*@sin(2*@acos(-1)*(@trend+1-ta)*f_)  'Generate the weighted individual cycles of the maximum ordinates of the periodogram.
				next
			endif
			delete f_ large_frequencies max_rank maximum1 maximum2 ranks ranks1 weight1 weight2 ta
		endif
		
		'----------------------------------------------Unweighted----------------------------------------------
		
		if check7=0 then 'Unweighted.
			
			if check6=1 then 'Sum.
				series {%f__}=0
				for !i=1 to !k
					scalar f_=large_frequencies(!i,1)
					scalar ta=@dtoo(@word(@pagesmpl,1))-1
					{%f__}={%f__}+@cos(2*@acos(-1)*(@trend+1-ta)*f_)+@sin(2*@acos(-1)*(@trend+1-ta)*f_) 'Generate the unweighted sum of the maximum ordinates of the periodogram.
				next
			endif
			
			if check6=2 then 'Individual.
				for !i=1 to !k
					scalar f_=large_frequencies(!i,1)
					scalar ta=@dtoo(@word(@pagesmpl,1))-1
					genr f_!i=@cos(2*@acos(-1)*(@trend+1-ta)*f_)+@sin(2*@acos(-1)*(@trend+1-ta)*f_)  'Generate the unweighted individual cycles of the maximum ordinates of the periodogram.
				next
			endif
			delete f_ large_frequencies max_rank maximum1 maximum2 ranks ranks1 ta
		endif
	endif
endif

delete a estimated_a aa b estimated_b bb check1 check2 check3 check4 check5 check6 check7 choice cosine frec frequency n pi q sine series series1 w periodogram periodogram1 ww

'-------------------------------------------------------------------------------------------------------------------------------------
'---------------------------------------------------Smoothing Subroutines-------------------------------------------------
'-------------------------------------------------------------------------------------------------------------------------------------
'The smoothing is applied to the peridogram i.e. it uses an spectral window.
' fw(Wk)=Sum(j=-M)(M) Wn(Wj) f(Wk-Wj)  the condition Sum(j=-M)(M) Wn(Wj) must sum one.
'Where Wn(Wj) is the spectral window and M the truncation point.
'-------------------------------------------------------------------------------------------------------------------------------------

'  ------------------------------------ Kernel | Subroutine Hamming window ------------------------------------------

subroutine local hamming(scalar band,series periodogram,series ww,series smooth_hamming)
	
	stom(periodogram,periodogram1) 'Vector object.
	stom(ww,w) 'Vector object.
	scalar n=@obs(periodogram1)*2 'Number of observations.
	series match01 'To save the periodogram over the range -pi<=w<=0 , by the symmetry property.
	series w1 'To save the fourier frequencys over the range -pi<=w<=0
	
	for !i=1 to @floor(n/2)
		match01(@floor(n/2)+1-!i)=periodogram1(!i)
		w1(@floor(n/2)+1-!i)=w(!i)
	next
	
	vector(n+@floor(n/2),1) period1 'To save the periodogram over the range -pi<=w<=2pi (periodicity property) and compute the spectral density.
	for !i=1 to @floor(n/2)
		period1(!i)=match01(!i)
		period1(!i+@floor(n/2))=periodogram1(!i)
		period1(!i+n)=match01(!i)
	next
	
	matrix(@floor(n/2),n) period 'To create a matrix of sections of the periodogram of size n.
	for !i=1 to @floor(n/2)
		for !j=1 to n
			period(!i,!j)=period1(!j+!i-1)
		next
	next
	
	vector(n,1) w2 'To create the fourier frequencys over the range -pi<=w<=pi.
	for !i=1 to @floor(n/2)
		w2(!i)=w1(!i)
		w2(!i+@floor(n/2))=w(!i)
	next
	
	vector(n,1) window1 ' To create the Hamming spectral window.
	for !i=1 to n
		window1(!i,1)=(0.23/(2*@acos(-1)))*(@sin((w2(!i)-@acos(-1)/band)*(band+1/2)))/(@sin((w2(!i)+@acos(-1)/band)/2))+((1-2*0.23)/(2*@acos(-1)))*(@sin(w2(!i)*(band+1/2))/@sin(w2(!i)/2))+(0.23/(2*@acos(-1)))*(@sin((w2(!i)+@acos(-1)/band)*(band+1/2)))/(@sin((w2(!i)+@acos(-1)/band)/2))
	next
	
	vector(@floor(n/2),1) smooth__hamming ' To compute spectral density.
	scalar prov
	for !i=1 to @floor(n/2)
		prov=@rowextract(period,!i)*window1/@sum(window1) ' The window must sum one.
		smooth__hamming(!i,1)=prov
	next
	
	mtos(smooth__hamming,smooth_hamming)
	
endsub

'  ------------------------------------ Kernel | Subroutine Hann window ------------------------------------------

subroutine local hann(scalar band,series periodogram,series ww,series smooth_hann)
	
	stom(periodogram,periodogram1) 'Vector object.
	stom(ww,w) 'Vector object.
	scalar n=@obs(periodogram1)*2 'Number of observations.
	series match01 'To save the periodogram over the range  -pi<=w<=0 , by the symmetry property.
	series w1 'To save the fourier frequencys over the range -pi<=w<=0.
	
	for !i=1 to @floor(n/2)
		match01(@floor(n/2)+1-!i)=periodogram1(!i)
		w1(@floor(n/2)+1-!i)=w(!i)
	next
	
	vector(n+@floor(n/2),1) period1 'To save the periodogram over the range -pi<=w<=2pi (periodicity property) and compute the spectral density.
	for !i=1 to @floor(n/2)
		period1(!i)=match01(!i)
		period1(!i+@floor(n/2))=periodogram1(!i)
		period1(!i+n)=match01(!i)
	next
	
	matrix(@floor(n/2),n) period 'To create a matrix of sections of the periodogram of size n.
	for !i=1 to @floor(n/2)
		for !j=1 to n
			period(!i,!j)=period1(!j+!i-1)
		next
	next
	
	vector(n,1) w2 'To create the fourier frequencys over the range -pi<=w<=pi.
	for !i=1 to @floor(n/2)
		w2(!i)=w1(!i)
		w2(!i+@floor(n/2))=w(!i)
	next
	
	vector(n,1) window1 ' To create the Hann spectral window.
	for !i=1 to n
		window1(!i,1)=(0.25/(2*@acos(-1)))*(@sin((w2(!i)-@acos(-1)/band)*(band+1/2)))/(@sin((w2(!i)+@acos(-1)/band)/2))+((1-2*0.25)/(2*@acos(-1)))*(@sin(w2(!i)*(band+1/2))/@sin(w2(!i)/2))+(0.25/(2*@acos(-1)))*(@sin((w2(!i)+@acos(-1)/band)*(band+1/2)))/(@sin((w2(!i)+@acos(-1)/band)/2))
	next
	
	vector(@floor(n/2),1) smooth__hann' To compute spectral density.
	scalar prov
	for !i=1 to @floor(n/2)
		prov=@rowextract(period,!i)*window1/@sum(window1) ' The window must sum one.
		smooth__hann(!i,1)=prov
	next
	
	mtos(smooth__hann,smooth_hann)
	
endsub

'  ------------------------------------ Kernel | Subroutine Bartlett window ------------------------------------------

subroutine local bartlett(scalar band,series periodogram,series ww,series smooth_bartlett)
	
	stom(periodogram,periodogram1) 'Vector object.
	stom(ww,w) 'Vector object.
	scalar n=@obs(periodogram1)*2 'Number of observations.
	series match01 'To save the periodogram over the range -pi<=w<=0 , by the symmetry property.
	series w1 'To save the fourier frequencys over the range -pi<=w<=0.
	
	for !i=1 to @floor(n/2)
		match01(@floor(n/2)+1-!i)=periodogram1(!i)
		w1(@floor(n/2)+1-!i)=w(!i)
	next
	
	vector(n+@floor(n/2),1) period1
	for !i=1 to @floor(n/2) 'To save the periodogram over the range -pi<=w<=2pi (periodicity property) and compute the spectral density.
		period1(!i)=match01(!i)
		period1(!i+@floor(n/2))=periodogram1(!i)
		period1(!i+n)=match01(!i)
	next
	
	matrix(@floor(n/2),n) period 'To create a matrix of sections of the periodogram of size n.
	for !i=1 to @floor(n/2)
		for !j=1 to n
			period(!i,!j)=period1(!j+!i-1)
		next
	next
	
	vector(n,1) w2 'To create the fourier frequencys over the range -pi<=w<=pi.
	for !i=1 to @floor(n/2)
		w2(!i)=w1(!i)
		w2(!i+@floor(n/2))=w(!i)
	next
	
	vector(n,1) window1 ' To create the Bartlett spectral window.
	for !i=1 to n
		window1(!i,1)=(1/(2*@acos(-1)*band))*((@sin(w2(!i)*band/2))/@sin(w2(!i)/2))^2
	next
	
	vector(@floor(n/2),1) smooth__bartlett ' To compute spectral density.
	scalar prov
	for !i=1 to @floor(n/2)
		prov=@rowextract(period,!i)*window1/@sum(window1) ' The window must sum one.
		smooth__bartlett(!i,1)=prov
	next
	
	mtos(smooth__bartlett,smooth_bartlett)
	
endsub

'  ------------------------------------ Kernel | Subroutine Parzen window ------------------------------------------

subroutine local parzen(scalar band,series periodogram,series ww,series smooth_parzen)
	
	stom(periodogram,periodogram1) 'Vector object.
	stom(ww,w) 'Vector object.
	scalar n=@obs(periodogram1)*2 'Number of observations.
	series match01 'To save the periodogram over the range -pi<=w<=0 , by the symmetry property.
	series w1 'To save the fourier frequencys over the range -pi<=w<=0.
	
	for !i=1 to @floor(n/2)
		match01(@floor(n/2)+1-!i)=periodogram1(!i)
		w1(@floor(n/2)+1-!i)=w(!i)
	next
	
	vector(n+@floor(n/2),1) period1
	for !i=1 to @floor(n/2) 'To save the periodogram over the range -pi<=w<=2pi (periodicity property) and compute the spectral density.
		period1(!i)=match01(!i)
		period1(!i+@floor(n/2))=periodogram1(!i)
		period1(!i+n)=match01(!i)
	next
	
	matrix(@floor(n/2),n) period 'To create a matrix of sections of the periodogram of size n.
	for !i=1 to @floor(n/2)
		for !j=1 to n
			period(!i,!j)=period1(!j+!i-1)
		next
	next
	
	vector(n,1) w2 'To create the fourier frequencys over the range -pi<=w<=pi.
	for !i=1 to @floor(n/2)
		w2(!i)=w1(!i)
		w2(!i+@floor(n/2))=w(!i)
	next
	
	vector(n,1) window1  ' To create the Parzen spectral window.
	for !i=1 to n
		window1(!i,1)=(3/(8*@acos(-1)*band^3))*((@sin(w2(!i)*band/4))/((1/2)*@sin(w2(!i)/2)))^4*(1-(2/3)*(@sin(w2(!i)/2))^2)
	next
	
	vector(@floor(n/2),1) smooth__parzen ' To compute spectral density.
	scalar prov
	for !i=1 to @floor(n/2)
		prov=@rowextract(period,!i)*window1/@sum(window1) ' The window must sum one.
		smooth__parzen(!i,1)=prov
	next
	
	mtos(smooth__parzen,smooth_parzen)
	
endsub

'  ------------------------------------ Kernel | Subroutine Truncated window ------------------------------------------

subroutine local truncated(scalar band,series periodogram,series ww,series smooth_truncated)
	
	stom(periodogram,periodogram1) 'Vector object.
	stom(ww,w) 'Vector object.
	scalar n=@obs(periodogram1)*2 'Number of observations.
	series match01 'To save the periodogram over the range  -pi<=w<=0 , by the symmetry property.
	series w1 'To save the fourier frequencys over the range -pi<=w<=0.
	
	for !i=1 to @floor(n/2)
		match01(@floor(n/2)+1-!i)=periodogram1(!i)
		w1(@floor(n/2)+1-!i)=w(!i)
	next
	
	vector(n+@floor(n/2),1) period1
	for !i=1 to @floor(n/2) 'To save the periodogram over the range -pi<=w<=2pi (periodicity property) and compute the spectral density.
		period1(!i)=match01(!i)
		period1(!i+@floor(n/2))=periodogram1(!i)
		period1(!i+n)=match01(!i)
	next
	
	matrix(@floor(n/2),n) period 'To create a matrix of sections of the periodogram of size n.
	for !i=1 to @floor(n/2)
		for !j=1 to n
			period(!i,!j)=period1(!j+!i-1)
		next
	next
	
	vector(n,1) w2 'To create the fourier frequencys over the range -pi<=w<=pi.
	for !i=1 to @floor(n/2)
		w2(!i)=w1(!i)
		w2(!i+@floor(n/2))=w(!i)
	next
	
	vector(n,1) window1  ' To create the Truncated spectral window.
	for !i=1 to n
		window1(!i,1)=(1/(2*@acos(-1)))*(@sin(w2(!i)*(band+1/2)))/@sin(w2(!i)/2)
	next
	
	vector(@floor(n/2),1) smooth__truncated ' To compute spectral density.
	scalar prov
	for !i=1 to @floor(n/2)
		prov=@rowextract(period,!i)*window1/@sum(window1) ' The window must sum one.
		smooth__truncated(!i,1)=prov
	next
	
	mtos(smooth__truncated,smooth_truncated)
	
endsub

'  ------------------------------------ Kernel | Subroutine Daniell window ------------------------------------------

subroutine local daniell(scalar band,series periodogram,series ww,series smooth_daniell)
	
	stom(periodogram,periodogram1) 'Vector object.
	stom(ww,w) 'Vector object.
	scalar n=@obs(periodogram1)*2 'Number of observations.
	series match01 'To save the periodogram over the range  -pi<=w<=0, by the symmetry property.
	series w1 'To save the fourier frequencys over the range -pi<=w<=0.
	
	for !i=1 to @floor(n/2)
		match01(@floor(n/2)+1-!i)=periodogram1(!i)
		w1(@floor(n/2)+1-!i)=w(!i)
	next
	
	vector(n+@floor(n/2),1) period1
	for !i=1 to @floor(n/2) 'To save the periodogram over the range -pi<=w<=2pi (periodicity property) and compute the spectral density.
		period1(!i)=match01(!i)
		period1(!i+@floor(n/2))=periodogram1(!i)
		period1(!i+n)=match01(!i)
	next
	
	matrix(@floor(n/2),n) period 'To create a matrix of sections of the periodogram of size n.
	for !i=1 to @floor(n/2)
		for !j=1 to n
			period(!i,!j)=period1(!j+!i-1)
		next
	next
	
	vector(n,1) w2 'To create the fourier frequencys over the range -pi<=w<=pi.
	for !i=1 to @floor(n/2)
		w2(!i)=w1(!i)
		w2(!i+@floor(n/2))=w(!i)
	next
	
	vector(n,1) window1  ' To create the Daniell spectral window.
	for !i=1 to n
		if w2(!i)>=-@acos(-1)/band and w2(!i)<=@acos(-1)/band then
			window1(!i,1)=band/(2*@acos(-1))
		endif
	next
	
	vector(@floor(n/2),1) smooth__daniell ' To compute spectral density.
	scalar prov
	for !i=1 to @floor(n/2)
		prov=@rowextract(period,!i)*window1/@sum(window1) ' The window must sum one.
		smooth__daniell(!i,1)=prov
	next
	
	mtos(smooth__daniell,smooth_daniell)
	
endsub

'  ------------------------------------ Kernel | Subroutine Bartlett-Priestley window ------------------------------------------

subroutine local priestley(scalar band,series periodogram,series ww,series smooth_priestley)
	
	stom(periodogram,periodogram1) 'Vector object.
	stom(ww,w) 'Vector object.
	scalar n=@obs(periodogram1)*2 'Number of observations.
	series match01 'To save the periodogram over the range  -pi<=w<=0 , by the symmetry property.
	series w1 'To save the fourier frequencys over the range -pi<=w<=0.
	
	for !i=1 to @floor(n/2)
		match01(@floor(n/2)+1-!i)=periodogram1(!i)
		w1(@floor(n/2)+1-!i)=w(!i)
	next
	
	vector(n+@floor(n/2),1) period1
	for !i=1 to @floor(n/2) 'To save the periodogram over the range -pi<=w<=2pi (periodicity property) and compute the spectral density.
		period1(!i)=match01(!i)
		period1(!i+@floor(n/2))=periodogram1(!i)
		period1(!i+n)=match01(!i)
	next
	
	matrix(@floor(n/2),n) period 'To create a matrix of sections of the periodogram of size n.
	for !i=1 to @floor(n/2)
		for !j=1 to n
			period(!i,!j)=period1(!j+!i-1)
		next
	next
	
	vector(n,1) w2 'To create the fourier frequencys over the range -pi<=w<=pi.
	for !i=1 to @floor(n/2)
		w2(!i)=w1(!i)
		w2(!i+@floor(n/2))=w(!i)
	next
	
	vector(n,1) window1  ' To create the Priestley spectral window.
	for !i=1 to n
		if @abs(w2(!i))<=@acos(-1)/band then
			window1(!i,1)=(3*band/(4*@acos(-1)))*((1-(band*w2(!i)/@acos(-1)))^2)
		endif
	next
	
	vector(@floor(n/2),1) smooth__priestley ' To compute spectral density.
	scalar prov
	for !i=1 to @floor(n/2)
		prov=@rowextract(period,!i)*window1/@sum(window1) ' The window must sum one.
		smooth__priestley(!i,1)=prov
	next
	
	mtos(smooth__priestley,smooth_priestley)
	
endsub

'  ------------------------------------ Signal tests for white noise ------------------------------------------

'--------------------------Wei (1994)-------------------------
' Fw=((Ak^2+Bk^2)/ V1)/(Sum(j=1)(j differet k)(n/2)(Ak^2+Bk^2)/ V2) ~ F(V1,V2)   --- Statistic
'The degrees of freedom depend on n (even or odd) and the frequency evaluated (the zero frequency is omited)
'---------------------------------------------------------------------------
'                                       N odd                 N even      
'---------------------------------------------------------------------------
'K=1,...,(n/2)-1                  -                    V1=2 V2=n-3           
'K=1,...,(n-1)/2        V1=1 V2=n-3                   -
'K=n/2                                -                    V1=1 V2=n-2    
'---------------------------------------------------------------------------
'----------------------------------------------------------------------------------------------------------------------

subroutine local test_signal(series periodogram,series statistic,series p_v,scalar n)
	
	genr a_b=periodogram^2 'To eliminate the square root.
	stom(a_b,data)  'Vector object.
	
	for !i=1 to @floor(n/2)
		vector(@floor(n/2),1) periodogram_s(!i,1)=@sum(a_b)-data(!i) ' For j different from k.
	next
	
	for !i=1 to @floor(n/2) 'Calculate the test for the ith ordinate.
		if n/2=@floor(n/2) then 'If n is even.
			if !i=@floor(n/2) then 'If the loop reaches the last ordinate.
				vector(@floor(n/2),1) f(!i,1)=(n-2)*data(!i)/(periodogram_s(!i,1)) 'There are one degree of freedom in the numerator (because the last B=0) and n-2 in the denominator (because the sum only omits the mean and the last B).
			else ' If the loop is different from the last ordinate.
				vector(@floor(n/2),1) f(!i,1)=(n-3)*data(!i)/(2*periodogram_s(!i,1)) ' Two degrees of freedom in the numerator (because A and B are different from 0) and n-3 in the denominator (because the sum omits the mean,the ith A and B).
			endif
		else 'If n is odd.
			vector(@floor(n/2),1) f(!i,1)=(n-3)*data(!i)/(2*periodogram_s(!i,1)) ' Two degrees of freedom in the numerator (because A and B are different from 0) and n-3 in the denominator (because the sum omits the mean and the ith A and B).
		endif
	next
	
	for !i=1 to @floor(n/2) 'To calculate the p-value.
		if n/2=@floor(n/2) then 'If n is even.
			if !i=@floor(n/2) then 'If the loop reaches the last ordinate.
				scalar prov=f(!i,1)
				vector(@floor(n/2),1) p_value(!i,1)=1-@cfdist(prov,1,n-2)
			else ' If the loop is different from the last ordinate.
				scalar prov=f(!i,1)
				vector(@floor(n/2),1) p_value(!i,1)=1-@cfdist(prov,2,n-3)
			endif      
		else 'If n is odd.
			scalar prov=f(!i,1)
			vector(@floor(n/2),1) p_value(!i,1)=1-@cfdist(prov,2,n-3)
		endif
	next
	
	mtos(f,statistic)
	mtos(p_value,p_v)
	
endsub

''-----------------Bartlett (1954) test for the normalized integrated spectrum--------------------
' Uk=Sum(k=1)(p) I(w)/Sum(k=1)(n/2) I(w)
'Confidence interval.
' p/(n/2)  a*(2/n)^(1/2)
'Where a=1.36 for the 95% confidence interval.
'--------------------------------------------------------------------------------------------------------------------
subroutine local bartlett_test(series periodogram,series uu,series ll_ic,series uu_ic)
	
	stom(periodogram,periodogram1)
	scalar prov=0
	vector(@obs(periodogram),1) U
	vector(@obs(periodogram),1) u_ic
	vector(@obs(periodogram),1) l_ic
	
	for !i=1 to @obs(periodogram)
		scalar prov=periodogram1(!i)+prov
		U(!i,1)=prov/@sum(periodogram)
		l_ic(!i,1)=!i/@obs(periodogram) -1.36*@sqrt(2/@obs(periodogram))
		u_ic(!i,1)=!i/@obs(periodogram)+1.36*@sqrt(2/@obs(periodogram))
	next
	
	mtos(u,uu)
	mtos(l_ic,ll_ic)
	mtos(u_ic,uu_ic)
	
endsub

'  ----------------------------------------------------------------------------------------------------------------
